
/* ********************************************************* */
/*                                                           */
/*     ⠪,              */
/* ⮫쪮  (a,b)=d,    楫 ᫠           */
/* x  y, ⠪  ax + by = d.                             */
/*                                                           */
/* ᥢ.                                                */
/*  :  ⥫ ᫠ a  b: a>=bvv         */
/*  : d=(a,b)  楫 x,y: ax + by = d.           */
/* 1.᫨ b=0  d:=a, x:=1, y:=0   (d,x,y) */ 
/* 2. x2:=1, x1:=0, y2:=0, y1:=1                     */
/* 3.  b>0                                               */
/*  3.1 q:=[a/b], r:=a-qb, x:=x2-qx1, y:=y2-qy1              */
/*  3.2 a:=b, b:=r, x2:=x1, x1:=x, y2:=y1, y1:=y             */
/* 4. d:=a, x:=x2, y:=y2   (d,x,y)        */
/*                                                           */
/* ********************************************************* */


// ७  
function extended_euclid(int a, int b, int *x, int *y, int *d)
/* calculates a * *x + b * *y = gcd(a, b) = *d */
{  
 int q, r, x1, x2, y1, y2;  
 
 if (b == 0) 
 {    
  *d = a; *x = 1; *y = 0;    
  return;  
 }  
 x2 = 1; x1 = 0; y2 = 0; y1 = 1;  

 while (b > 0) 
 {    
  q = a / b; r = a - q * b;    
  *x = x2 - q * x1; *y = y2 - q * y1;    
  a = b; b = r;    
  x2 = x1; x1 = *x; y2 = y1; y1 = *y;    
 }  
 *d = a; *x = x2; *y = y2;  
}


//  㪭
function Start()
{  
 int a = 1, b = 2, d, x, y;  
 
 extended_euclid(a, b, &x, &y, &d);  
 
 print(x) 
 print(y)
 print(d)
}
