
//  ﭨ 
type MouseState 
{
    int x,y;
    int buttons;
} //ms = {0, 0, 0};


function int ResetMouse()
{
 assembler 
 { 
	xor	ax, ax
        int	33h
        cmp	ax, 0ffffh
        je	_99020
        mov	ax, 0
        jmp	_99021
_99020:	mov	ax, 1
_99021:
 }
}


// 㭪 ⮡ࠦ  
function ShowMouseCursor()
{
 assembler
 { 
	mov	ax, 1
	int	33h
 }
}


// 㭪 뢠  
function HideMouseCursor()
{
 assembler
 { 
	mov	ax, 2
	int	33h
 }
}


// 㭪 ⠭    . X,Y
function MoveMouseCursor(int x,int y)
{
 assembler
 { 
	mov	ax, 4
	mov	cx, [bp+4]
	mov	dx, [bp+6]
	int	33h
 }
}


// 㭪 ⠥ ﭨ 
// , ﭨ 
function ReadMouseState(MouseState *ps)
{
 assembler
 { 
	mov	ax, 3
	int	33h
	push	di
	mov	di, [bp+4]
	mov	[di], cx
	mov	[di+2], dx
	mov	[di+4], bx
	pop	di
 }
}


// 㭪 ⠭  ६饭   ਧ⠫
function SetMouseHoriz(int min,int max)
{
 assembler
 { 
	mov	ax, 7
	mov	cx, [bp+4]
	mov	dx, [bp+6]
	int	33h
 }
}


// 㭪 ⠭  ६饭   ⨪
function SetMouseVert(int min,int max)
{
 assembler
 { 
	mov	ax, 8
	mov	cx, [bp+4]
	mov	dx, [bp+6]
	int	33h
 }
}


// 1 - ᫨  -  㪠 
function int MouseInArea(int x1,int y1,int x2,int y2)
{
    MouseState ms;
    
    ReadMouseState(&ms);
    if(ms.x>=x1 && ms.x<=x2 && ms.y>=y1 && ms.y<=y2) return(1);
    else return(0);
}

// ⠭  ६饭 
function SetMouseArea(int x1,int y1,int x2,int y2)
{
    SetMouseHoriz(x1,x2);
    SetMouseVert(y1,y2);
}
 


function char getch()
{
 assembler
 {
	mov	ah, 7
	int	21h
 }
}
 

function byte getmode()
{
 assembler
 {
	mov	ah, 0fh
	int	10h
 }
}


function setmode(byte mode)
{
 assembler
 {
	mov	ah, 0
	mov	al, byte ptr [bp+4]
	int	10h
 }
}


function setpalette(byte palette)
{
 assembler
 {
	mov	ah, 0bh
	mov	bh, 1
	mov	bl, byte ptr [bp+4]
	int	10h
 }
}

function setpixel(byte color, word hpos, word vpos)
{
 assembler
 {
	mov	ah, 0ch
	mov	al, byte ptr [bp+4]
	mov	cx, [bp+6]
	mov	dx, [bp+8]
	int	10h
 }
}


function Start()
{
 word x0 = 200, y0 = 160, cx = 240, cy = 160
 byte color = 1, mode
 MouseState ms = {0, 0, 0};
 
 mode = getmode()
 setmode(0x12)
 setpalette(0);
 
 for(int i = 0; i < cx; i++)
  setpixel(color, x0 + i, y0)
 
 word x1 = x0 + cx
 for(int i = 0; i < cy; i++)
  setpixel(color, x1, y0 + i)
  
 word y1 = y0 + cy
 for(int i = 0; i < cx; i++)
  setpixel(color, x0 + i, y1)

 for(int i = 0; i < cy; i++)
  setpixel(color, x0, y0 + i)
  
 if(ResetMouse())
 {
  ShowMouseCursor()
  SetMouseArea(x0, y0, x1, y1)
  MoveMouseCursor(x0 + cx / 3, y0 + cy / 4)
  //getch()
  MouseState *pms = &ms
  //while(ms.buttons != 2 && ms.buttons != 1)
  while(pms->buttons != 2 && pms->buttons != 1)
  {
   pms->buttons = 0
   ReadMouseState(pms)
  }
  HideMouseCursor()
 }
 setmode(mode)
}
